IDEAL
P386
MODEL SMALL

CODESEG
	ASSUME CS:_TEXT,DS:_TEXT,ES:_TEXT

start:	mov	ax,cs		; Initialize Data
	mov	ds,ax		; Segment

	mov	si,offset msg1	; Display
	call	print		; msg1
	xor	dl,dl		; Drive 0 (Floppy)
reset:	xor	ah,ah		; Reset
	int	13h		; !
	jc	reset		; Retry if busy

	mov	si,offset msg2	; Display
	call	print		; msg2
	mov	cx,1		; Sector 1 (Bootsector)
	xor	dx,dx		; from Drive 0 
	mov	es,dx		; to Segment 0000
	mov	bx,7C00h	;    Offset  7C00
read:	mov	ax,201h		; read 1 Sector
	int	13h		; !
	jc	read		; On error retry

	mov	si,offset msg3	; Display
	call	print		; msg3
	jmp	far 0:7C00h	; Execute Bootcode


print:	lodsb			; Get current character into al
	or	al,al		; Check for trailing 0-byte
	jz	print0		; Finished printing
	mov	ah,0Eh		; Print out character
	int	10h		; !
	jmp	print		; goto next character
print0:	ret			; return

; Messages
msg1	db "* Initializing disk",13,10,0
msg2	db "* Loading bootsector",13,10,0
msg3	db "* Executing bootsector:",13,10,0

ENDS

END	start


